#include<bits/stdc++.h>
using namespace std;
int x[1005],xx[1005],n,m,v;
bool check(int a,int b)
{
	for(int i=1;i<=1005;i++)
	xx[i]=x[i];
	for(int i=1;i<=n;i++)
	{
		if(xx[i]==a)
		{
			if(!xx[i+1])
			xx[i+1]=b;
			else return false;
		}
	}
	return true;
} 
int main()
{
	freopen("assign.in","r",stdin);
	freopen("assign.out","w",stdout);
	int T;
	cin>>T;
	while(T--)
	{
		memset(x,0,sizeof(x));memset(xx,0,sizeof(xx));
		int res=0;
		cin>>n>>m>>v;
		for(int i=1;i<=m;i++)
		{
			int c,d;
			cin>>c>>d;
			x[c]=xx[c]=d;
		}
		for(int a=1;a<=v;a++)
		for(int b=1;b<=v;b++)
			if(check(a,b))	res++;
		cout<<res<<endl;
	}
	return 0;
}
